package com.banesco.module.security_notification.infrastructure.client;

import com.banesco.common.application.helper.SerializationHelper;
import com.banesco.common.application.usecase.HttpClientUseCase;
import com.banesco.common.domain.exception.HttpStatusCodeException;
import com.banesco.common.domain.exception.ApiPrivateException;
import com.banesco.common.domain.model.*;
import com.banesco.common.infrastructure.config.RestClientConfig;
import com.banesco.module.security_notification.application.usecase.SecurityNotificationUseCase;
import com.banesco.module.security_notification.domain.dto.request.SecurityNotificationRequest;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.inject.Inject;
import lombok.extern.slf4j.Slf4j;

import java.util.List;
import java.util.Map;

@Slf4j
@ApplicationScoped
public class SecurityNotificationClient implements SecurityNotificationUseCase {
    private final SerializationHelper serializationHelper;
    private final HttpClientUseCase httpClientUseCase;
    private final SecurityNotificationConfig securityNotificationConfig;

    private static final String EMPTY_MESSAGE = "EMPTY_MESSAGE";

    @Inject
    public SecurityNotificationClient(
        SerializationHelper serializationHelper,
        HttpClientUseCase httpClientUseCase,
        RestClientConfig restClientConfig
    ) {
        this.serializationHelper = serializationHelper;
        this.httpClientUseCase = httpClientUseCase;
        this.securityNotificationConfig = restClientConfig.getSecurityNotificationConfig();
        log.info("Configuracion cargada para payment-status: {}", securityNotificationConfig);
    }

    @Override
    public <T> List<T> execute(
        SecurityNotificationRequest params,
        Class<T> responseType
    ) {
        String fintechId = params.getFintechId();
        String signatureIdentifier = getSignatureIdentifier(params);
        HttpRequest request = HttpRequest.forApiPrivateResponseList(
                securityNotificationConfig.getUrl(),
                securityNotificationConfig.getStatusSuccess(),
                HttpRequest.HttpMethod.GET,
                responseType
            )
            .withPathParams(Map.of("signatureIdentifier", signatureIdentifier))
            .withHeaders(Map.of("fintechId", fintechId))
            .withTimeout(
                securityNotificationConfig.getTimeout().getConnect(),
                securityNotificationConfig.getTimeout().getResponse()
            );

        try {
            ApiPrivateResponse<Either<List<T>, ApiPrivateError>> response =
                httpClientUseCase.executeApiPrivateResponseList(request);
            Either<List<T>, ApiPrivateError> detail = response.getDetalle();

            if(detail == null) {
                log.error(
                    "API retorno exitoso pero con detalle vacio. Codigo: {}, Mensaje: {}",
                    response.getEstatus(),
                    response.getMensaje()
                );

                throw ApiPrivateException.builder()
                    .statusCode("PIBE-00")
                    .message(EMPTY_MESSAGE)
                    .build();
            }

            if (detail.isLeft()) {
                if(detail.getLeft() == null) {
                    throw ApiPrivateException.builder()
                        .statusCode("PIBE-00")
                        .message(EMPTY_MESSAGE)
                        .build();
                }
                
                return detail.getLeft();
            }

            ApiPrivateError error = detail.getRight();

            log.error(
                "API privada retorno error. Codigo: {}, Mensaje: {}, Error Interno: {} -> {}",
                response.getEstatus(),
                response.getMensaje(),
                error.getCodError(),
                error.getMensajeError()
            );

            throw ApiPrivateException.builder()
                .statusCode("PIBE-01")
                .message((error.getCodError() != null)
                    ? error.getCodError() + ":" + error.getMensajeError()
                    : EMPTY_MESSAGE
                )
                .build();
        } catch (ApiPrivateException e) {
            throw e;
        } catch (HttpStatusCodeException e) {
            log.error(
                "Error HTTP consultando cliente {}: {} - {}",
                signatureIdentifier,
                e.getStatusCode(),
                e.getMessage()
            );
            throw e;
        } catch (Exception e) {
            log.error("Error consultando cliente {}: {}", signatureIdentifier, e.getMessage());
            throw HttpStatusCodeException.serviceUnavailable("503");
        }
    }

    private String getSignatureIdentifier(SecurityNotificationRequest params) {
        Map<String, Object> securityNotificationRequest = serializationHelper.toMap(params);
        String signature = serializationHelper.generateSignature(
            params.getId(), params.getChannelOrigin()
        );

        securityNotificationRequest.put("signature", signature);

        securityNotificationRequest.remove("fintechId");

        String signatureIdentifier = serializationHelper.encodeBase64(securityNotificationRequest);

        log.info("3. Firma generada: {}", signature);
        log.info("4. Parametros de la solicitud: {}", securityNotificationRequest);
        log.info("5. Solicitud final: {} -> {}", securityNotificationRequest, signatureIdentifier);

        return signatureIdentifier;
    }
}